//********************************************************************
//Aerator.java       Author: Carlos Rios
//
// Collaboration Statement: I worked alone, using various internet sources
//********************************************************************

import java.awt.*;
import javax.swing.*;
/**
* Implements a graphical image of an aerator that can be placed in an  aquarium.
* It can be placed at a specific location in the aquarium and it 
* produces moving bubbles of air.
* @author Carlos Rios
* @version 1.0
*/

public class Aerator implements AquariumObject {  // Represents an
            // aquarium air bubbler
				
	/** the x coordinate of the bottom and middle point on the aerator */
	int xAerator;
	/** the y coordinate of the bottom and middle point on the aerator */
	int yAerator;
	/** the maximum height of the bubbles produced by the aerator */
	int heightAerator;
	/** the number of bubbles simultaneously viewed  */
	int numBubbles;
	/** the distance between each bubble */
	int deltaBubble;
	/** the diameter of  each bubble */
	int sizeBubble;
	/** the x coordinate of the first bubble */
	int xBubble;
	/** the y coordinate of the first bubble */
	int yBubble;
	/** iteration parameter used in the representation of moving bubbles */
	int iteration;
	/** a polygon representing the shape of the aerator */
	Polygon aeratorPolygon;
	
	/**
	 *	 Creates an instance of a an Aerator.
	 * @param x The x coordinate of  bottom  and middle point on the aerator
	 * @param y The y coordinate of  bottom  and middle point on the aerator
	 * @param eheight The maximum height of the bubbles. 	 
	 */
   public Aerator(int x, int y, int eheight) 
	  // The x and y parameters
       // denote the bottom center position of the aerator and the 
       // height parameter specifies how high the bubbles should go
       // above that coordinate.
		 {	
			

			int[] xa = {0,20,20,30,30,20,20,10,10,-10,-10,-20,-20,-30,-30,-20,-20};
               
      	int[] ya = {0,0,-40,-40,-50,-50,-80,-80,-90,-90,-80,-80,-50,-50,-40,-40,0};
                
			Polygon poly = new Polygon(xa, ya, xa.length);
			xAerator=x;
			yAerator=y;
			heightAerator=eheight;
			poly.translate(xAerator,yAerator);
			aeratorPolygon=poly;
			
			numBubbles=(eheight-90)/40;
			deltaBubble=1;
			sizeBubble=20;
			xBubble=x-10;
			yBubble=y-110;
			iteration=0;		
		 }
		 
		/**
	 *	 Paints the aerator and moves the bubbles on each call .
	 * @param g The graphics context for painting.Represents an AquariumPanel 
	 */

   public void paint(Graphics g)  	
	  // Redraw the aerator.  NOTE:
       // subsequent class to paint should slightly change the
       // positions of bubbles so it looks like the aerator is running
       // and sending bubbles up to the surface.
		 {
		   g.setColor(Color.black);
			g.fillPolygon(aeratorPolygon);
			g.setColor(Color.white);
			int yPosition=yBubble-(iteration*deltaBubble);
		
				for (int i=0;i<numBubbles; i++)
				{
				g.fillOval(xBubble,yPosition,20,20);
				yPosition-=40;			
				}
				
			iteration+=1;
			if(iteration==20)
			iteration=0;
			

		}
		
		
		 
}