//********************************************************************
//Aquarium.java       Author: Carlos Rios
//
// Collaboration Statement: I worked alone, using various internet sources
//********************************************************************


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ArrayList;

/**
* Implements the Jframe for an aquarium
* @author Carlos Rios
* @version 1.0
*/
public class Aquarium extends JFrame {
	// instance variables
	/** The color of thr water in the aquarium. */
	Color backgroundColor= new Color(109, 171, 177);
	/** The size of the aquarium. */
	Dimension size;
	/** The width of the aquarium.*/
	int awidth;
	/** The height of the aquarium.*/
	int aheight;
	/** An array  that contains animals in the aquarium. */
	ArrayList<AquariumObject> objectArray ;
	/** The graphics context for painting the animals in the aquarium.*/
	Graphics g ;
	/** The JPanel on which the animals are drawn. */
	JPanel aquariumPanel;
	
	/**  The buffer that support doubke buffering to remove flickering  */
	Image aquariumBuffer;
	

	
	
	
	// Constructor
		/**
	 *	 Creates an instance of a an Aquarium.
	 * @param width The width of the aquarium
	 * @param height  The height of the aquarium. 	 
	 */
   public Aquarium(int width, int height)
	{	
		super("Aquarium");
		objectArray =new ArrayList<AquariumObject>();
		awidth=width;
		aheight=height;
		size= new Dimension(awidth,aheight);
	   aquariumPanel = new JPanel();
		aquariumPanel.setBackground(backgroundColor);
		aquariumPanel.setPreferredSize( size);	
		getContentPane().add(aquariumPanel);
		setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
      pack();
      setVisible(true);
		
		g=aquariumPanel.getGraphics();


		 
		 
	}
	// Get the color of the water
	
	/**
	 *	Getter for the color of the water
	 * @return  The color of the water 	 
	 */
	 
   public Color getWaterColor()
	{
	return backgroundColor;
	}
	// get the size of the aquarium (width and height)
	
	/**
	 *	Getter for the size of the aquarium
	 * @return  The size of the aquarium	 
	 */
	 
	public Dimension getSize()
	{
	return size;
	}
	
// Get the reference to the graphics object

		/**
	 *	Getter for the reference to the graphics object
	 * @return   The graphics context 	 
	 */
	 
   public Graphics getGraphicsContext()
	{
	return g;
	}
	
// add an object to the aquarium

	/**
	 *	Associates a graphical object with the aquarium
	 * @param ao  An object to be associated with the aquarium..	 
	 */

   public void addObject(AquariumObject ao)
	{
	boolean added;
	added=objectArray.add(ao);

	}
// refresh the view of the aquarium

	/**
	 *	Redraws the aquarium and it's contents.
	* @param gr the graphics object for redrawing	 
	 */
   public void refresh(Graphics gr)
	{ 
	aquariumPanel.paint(gr);
	
	for (int i=0;i<objectArray.size();i++)
		{
		objectArray.get(i).paint(gr);
		}

	}
	


}