//********************************************************************
//Crab.java       Author: Carlos Rios
//
// Collaboration Statement: I worked alone, using various internet sources
//********************************************************************

import java.awt.*;
import javax.swing.*;
/**
* Implements a graphical image of an crab that can be placed in an  aquarium.
* It can be placed at a specific location in the aquarium.
* @author Carlos Rios
* @version 1.0
*/

public class Crab implements AquariumObject {
	/** the x coordinate of the bottom and middle point on the crab */
	int xCrab;
	/** the y coordinate of the bottom and middle point on the crab */
	int yCrab;
	/** a polygon implementing the shape of the crab */
	Polygon crabPolygon;
	
		/**
	 *	 Creates an instance of a an Crab.
	 * @param x The x coordinate of  bottom  and middle point on the crab
	 * @param y The y coordinate of  bottom  and middle point on the crab 
	 */
   public Crab(int x, int y)  // The x and y parameters denote the 
         // bottom-center of the crab.  You can make it some arbitrary
         // (possibly random) reasonable size.
			{
			
			
			int[] xa = {0,32,44,60,72,42,55,77,82,76,50,74,88,112,108,115,120,118,92,73,60,69,66,15,15,7,7,0,-7,-7,-15,-15,-66,-69,-60,-73,-92,-118,-120,-115,-108,-112,-88,-74,-56,-76,-82,-77,-55,-42,-73,-60,-44,-32};
               
      	int[] ya = {-60,-60,-42,-45,-32,0,0,-30,-35,-45,-57,-57,-68,-44,-28,-23,-45,-55,-74,-79,-83,-92,-103,-105,-127,-127,-110,-110,-110,-127,-127,-105,-103,-92,-83,-79,-74,-55,-45,-23,-28,-44,-68,-57,-57,-45,-35,-30,0,0,-32,-45,-42,-60};
                
			Polygon poly = new Polygon(xa, ya, xa.length);
			xCrab=x;
			yCrab=y;
			poly.translate(xCrab,yCrab);
			crabPolygon=poly;			
			}
	/**
	 *	 Paints the crab .
	 * @param g The graphics context for painting.
	 */		
   public void paint(Graphics g) 
	{
			   g.setColor(Color.red);
			g.fillPolygon(crabPolygon);

		
	
	}  // Draw the crab
}