//********************************************************************
//Fish.java       Author: Carlos Rios
//
// Collaboration Statement: I worked alone, using various internet sources
//********************************************************************


import java.awt.*;
import javax.swing.*;
/**
* Implements a graphical image of an fish that can be placed in an  aquarium.
* It can be placed at a specific location in the aquarium.
* It can paint fish of different colors.
* It can draw fish of different shapes or it can draw a default fish shape.
* @author Carlos Rios
* @version 1.0
*/

public class Fish implements AquariumObject {

			// instance variables
			/** the color of the fish */
			Color fishColor;
			/** a polygon implementing the shape of the fish */
			Polygon fishPolygon;
			/** the x coordinate of the location of the fish */
			int xFish;
			/** the x coordinate of the location of the fish */
			int yFish;



	/**
	 *	 Creates an instance of a an Fish.
	 * @param c The color of the Fish
	 * @param p The polygon representing the shape of the fish
	 * @param x The x coordinate of the location of the Fish
	 * @param y The y coordinate of the location of the Fish
	 */
   public Fish(Color c, Polygon p, int x, int y)  // Use the
         // specified polygon as the fish outline.  The coords are
         // relative to the x,y.  Make it the given solid color.
			{
			fishColor=c;
			xFish=x;
			yFish=y;
			fishPolygon= new Polygon(p.xpoints,p.ypoints,p.xpoints.length);
			fishPolygon.translate(xFish,yFish);
		
			
			
			}
			
		/**
	 *	Creates an instance of a an Fish.Uses the default shape and color.
	 * @param x The x coordinate of the location of the Fish
	 * @param y The y coordinate of the location of the Fish
	 */
   public Fish(int x, int y)   // Create some random (but decent)
         // looking fish at the given position
			{
			int[] xa = {0, 30, 40, 50, 60, 70, 90, 100, 98,
                 88, 98, 100, 90, 70, 60, 50, 40, 30, 0, 15};
      	int[] ya = {5, 15, 10, 7, 0, 7, 12, 15, 22, 25, 28, 35, 40,
                 43, 50, 43, 40, 35, 45, 25};

			Polygon poly = new Polygon(xa, ya, xa.length);
			Color c = Color.blue;
			fishColor=c;
		
			xFish=x;
			yFish=y;
			poly.translate(xFish,yFish);
			fishPolygon=poly;
			
			
			}
	public Fish()
	{
	}
	
	/**
	 *	 Paints the Fish .
	 * @param g The graphics context for painting.
	 */
		
   public void paint(Graphics g) 
  // Draw the fish
  { 
  g.setColor(fishColor);
  g.fillPolygon(fishPolygon);
  
  
  }
}