//********************************************************************
//Sand.java       Author: Carlos Rios
//
// Collaboration Statement: I worked alone, using various internet sources
//********************************************************************

import java.awt.*;
import javax.swing.*;

/**
* Implements a graphical image of sand that can be placed in an  aquarium.
* It can be placed at a specific location and have a specified width.
* @author Carlos Rios
* @version 1.0
*/
public class Sand implements AquariumObject {  // Simulates the
             // gravel or sand that sits on the bottom of an aquarium
				 
	/** the bounding box location ( x- coordinate) for an arc that represents part of a sand bank */			 
	int bBoxX;
	/** the bounding box location ( y- coordinate) for an arc that represents part of a sand bank */	
	int bBoxY;
	/** the width of the sand bank */
	int width;
	/** the height of the sand bank */
	int height= 50;
	
	
	/**
	 *	 Creates an instance of a an bank of sand.
	 * @param x The x coordinate of  bottom  and middle point on the sand bank
	 * @param y The y coordinate of  bottom  and middle point on the sand bank
	 * @param ewidth The width of the sand bank	 
	 */	
   public Sand(int x, int y, int ewidth) 	
	 // The parameters specify
         // the bottom-center position of the sand within its
         // graphical context and the width specifies how wide it
         // should be.  It should be relatively short too.
			{
			bBoxX=x-(ewidth/2);
			bBoxY=y-(height/2);
			width=ewidth;
			
			}
	
	
	/**
	 *	 Paints the sand bank
	 * @param g The graphics context for painting.
	 */
   public void paint(Graphics g)
  // Redraw the sand
  {
  int arcX=bBoxX;
  int arcY=bBoxY;
  int arcWidth= width/5;
  int arcHeight=height;
   g.setColor(Color.yellow);
	
  for(int i=0;i<10;i++)
  { 
  g.fillArc(arcX,arcY,arcWidth,arcHeight,0,180);
  arcX+=arcWidth/2;

  }
	
  }
}