


import java.awt.*;
import javax.swing.*;

//********************************************************************
//UnderwaterPlant.java       Author: Carlos Rios
//
// Collaboration Statement: I worked alone, using various internet sources
//********************************************************************

/**
* Implements a graphical image of an underwater plant  that can be placed in an  aquarium.
* It can be placed at a specific location in the aquarium and it 
* can have a specified width and height.
* @author Carlos Rios
* @version 1.0
*/
public class UnderwaterPlant implements AquariumObject {  // Represents
              // a plant.  Feel free to make each one created have its
              // own unique appearance.
				  
	/** the x coordinate of the bottom and middle point on the plant */
	int xPlant;
	/** the y coordinate of the bottom and middle point on the plant */
	int yPlant;
	/** a polygon representing the shape of the underwater plant */
	Polygon plantPolygon;
	
	
	/**
	 *	 Creates an instance of a an underwater plant.
	 * @param x The x coordinate of  bottom  and middle point on the plant
	 * @param y The y coordinate of  bottom  and middle point on the plant
	 * @param width  The maximum width of the plant
	 * @param height The maximum height of the palnt
	 */
   public UnderwaterPlant(int x, int y, int width, int height)
       // The x and y parameters denote the bottom center coordinate
       // of the plant.  The width and height denote the maximum size
       // this plant can be (smaller is OK).
		 {
		 
			int[] xa = {1,1,8,4,8,4,6,4,0,-4,-6,-4,-8,-4,-8,-1,-1};
               
      	int[] ya = {0,-2,-2,-4,-5,-6,-8,-8,-10,-8,-8,-6,-5,-4,-2,-2,0};
			int xFactor=width/8;
			int yFactor=height/10;
			for(int i=0;i<xa.length;i++)
			xa[i]=xa[i]*xFactor;
			for(int j=0;j<ya.length;j++)
			ya[j]=ya[j]*yFactor;

                
			Polygon poly = new Polygon(xa, ya, xa.length);
			xPlant=x;
			yPlant=y;
			poly.translate(xPlant,yPlant);
			plantPolygon=poly;	
		 }
		 
	/**
	 *	 Paints the underwater plant.
	 * @param g The graphics context for painting.
	 */			 
   public void paint(Graphics g)
	{
	 
		   g.setColor(Color.green);
			g.fillPolygon(plantPolygon);	
				
	}   // Redraw the plant
}